<?PHP
/*
  version_checker.php - 12/4/2021 - 10:15am PST - v3
  
  Turnkey Web Tools, Inc.
  http://www.twt-inc.com/
  
  Copyright (c) 2001-2021 Turnkey Web Tools, Inc.
*/

if (1==0) {
  echo "PHP does not seem to be functioning or it is not installed correctly. Please contact your system administrator.<!--//";
  exit;
}

// Set Time Zone
@ini_set('date.timezone', 'America/Los_Angeles');
@date_default_timezone_set('America/Los_Angeles');

@set_time_limit(0);
ini_set('display_errors', '1');
ini_set('error_reporting', E_ALL ^E_DEPRECATED ^E_NOTICE ^E_WARNING);

$vars = array();
$vars['software']		= "Version Checker";
$vars['version']		= "3.0";
$vars['year']			= date('Y');
$vars['main_content'] 	= '';
$vars['mode']			= '';

$steps = array(
	'0' => array('title' => 'Server Checks', 'status' => 'm_active'),
);

$vars['current_step']	= 1;
$vars['total_step']		= count($steps);

function display_check ($check, $result='', $instructions='', $colors='') {
	global $display_bg;
	$colors = (!is_array($colors))?array('#000000', '#008000', '#000000'):$colors;
	$display_bg = ($display_bg=='#EFEFEF')?'#FFFFFF':'#EFEFEF';
	return '
		<div style="background-color: '.$display_bg.'; padding: 5px;">
			<div style="width: 55%; float: left; text-align: left; color: '.$colors[0].'; font-weight: bold; vertical-align: top;">'.$check.':</div>
			<div style="width: 40%; float: right; text-align: right; color: '.$colors[1].'; font-weight: bold;">'.$result.'</div>
			<div style="width: 100%; clear: both; color: '.$colors[2].'; padding: 2px;">'.$instructions.'</div>
		</div>
	';
}

$vars['main_content']	 = system_checks();
$vars['main_content'] 	.= run_checks();
$vars['next_step']		 = '';

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head>
		<title>Turnkey Web Tools, Inc. - <?PHP echo $vars['software']; ?> <?PHP echo $vars['mode']; ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
		<style>
		a:visited {	color: #2d5f9d; text-decoration: none; }
		a:hover { color: #EB0101; text-decoration: underline; }
		a:link { color: #2d5f9d; text-decoration: none; }
		body, td {
			font-family: verdana, arial, helvetica;
			font-size: 14px;
		}
		body { margin: 0px; padding: 0px; }
		.red_button {
			font-family: verdana, helvetica, arial, sans-serif;
			font-size: 14px;
			font-weight: bold;
			color: #EB0101;
			padding: 10px 20px 10px 20px;
			background-color: #FFFFFF;
			border: 1px solid;
			vertical-align:top;
			cursor:pointer;
		}
		.red_button:hover {
			font-family: verdana, helvetica, arial, sans-serif;
			font-size: 14px;
			font-weight: bold;
			color: #FFFFFF;
			padding: 10px 20px 10px 20px;
			background-color: #EB0101;
			border: 1px solid;
			vertical-align:top;
			cursor:pointer;
		}
		.agreement {
			position: relative; 
			width: 98%; 
			height: 400px; 
			background-color: #EFEFEF; 
			overflow: auto; 
			padding: 10px;
		}		 
		.input_text {
			color: #000000;
			font-size: 14px;
			border: 1px solid #CDCDCD;
			padding: 1px;
			margin: 1px;
		}
		.lic_text { 
			font-family: courier new; 
			font-size: 13px; 
			background: #ebebe4; 
			width: 100%;
			height: 400px;
		}
		.lic_key {
			font-family: courier new;
			font-size: 14px;
			background: #ebebe4;
			width: 250px;
		}
		.menu_title {
			font-size: 15px;
			color: #454545;
			font-weight: bold;
			vertical-align: middle;
			height: 20px;
			margin-bottom: 15px;
			width: 100%;
		}
		.menu {
			text-decoration: none;
			margin: 0 0 0 0;
			border: 1px solid #CDCDCD;
			background-color: #FFFFFF;
			-moz-border-radius: 4px 4px 0px 0px;
			color: #61718c;
			width: 100%;
		}
		.input_text {
			height: 20px;
			font-size: 14px;
			padding: 5px;
		}
		.menu_area {
			padding: 5px;
		}

		td.menu_bar {
			width: 200px;
		}

		.menu_bar {
			background-color: #E7E7E7; 
			padding: 6px;
			
		}
		.menu_item {
			background: #ffffff url('http://www.-inc.com/images/installer/right_arrow.png') no-repeat center left;
			padding-left: 15px;
			color: #666666;
		}
		table.user_form td { padding-bottom: 10px; }
		a.m_active { color: #666666; }
		a.m_inactive { color: #CCCCCC; }
		a.m_complete { color: #666666; text-decoration: line-through; }
		.footer {
			width: 100%; 
			background-color: #707070; 
			height: 20px; color: #FFFFFF; 
			font-size: 13px;
			line-height: 20px;
			padding-left: 10px; 
			padding-top: 3px; 
			padding-bottom: 3px; 
			font-weight: bold; 
			text-align: center; 
			vertical-align: middle;
		}
		.message_bar {
			width: 100%; 
			background-color: #727172; 
			height: 20px; 
			line-height: 20px;
			color: #FFFFFF; 
			font-size: 13px; 
			padding-left: 10px; 
			padding-top: 3px; 
			padding-bottom: 3px; 
			font-weight: bold;
		}
		.alert_message {	
			background: #FFFFFF;
			border: solid #33cc00 1px;
			padding: 10px;
			margin-bottom: 10px;
		}
		.error_alert {
			margin-left: 35px;
		}

		</style>
	</head>

	<body>
		<form name="install_upgrade" method="post" action="">
		<input type="hidden" name="step" value="<?PHP echo $vars['next_step']; ?>">
		<input type="hidden" name="mode" value="<?PHP echo isset($_POST['mode'])?$_POST['mode']:''; ?>">
		
		<img src="https://www.twt-inc.com/images/installer/logo.gif" border="0" style="padding: 10px;" />

		<div style="width: 100%; background-color: #C6C3C6; height: 1px;"></div>
		<div style="width: 100%; background-color: #E7E7E7;; height: 4px;"></div>
		<div class="message_bar">
			Current Step: <?PHP echo $steps[$vars['current_step']-1]['title']; ?> (Step <?PHP echo $vars['current_step']; ?> of <?PHP echo $vars['total_step']; ?>)
		</div>
		<div style="width: 100%; background-color: #E7E7E7;; height: 4px;"></div>

		<table width="100%" border="0" cellspacing="0" cellpadding="0">
			<tr>
				<td width="170" rowspan="2" align="left" valign="top" bgcolor="#E7E7E7" class="menu_bar">
					<div class="menu">
						<div class="menu_area">
							<div class="menu_title">
								<img src="http://www.turnkeywebtools.com/images/installer/title_head.png" align="absmiddle" border="0" style="padding-right: 5px;"><?PHP echo $vars['mode']; ?> Steps	
							</div>
							<div style="padding-left: 2px;">
								<?PHP
								foreach ($steps as $k => $v) {
									echo '<a href="javascript: void();" class="menu_item '.$steps[$k]['status'].'">'.$steps[$k]['title'].'</a><div style="margin-top: 3px"></div>';
								}
								?>
							</div>
						</div>
					</div>
				</td>
				<td width="1px" bgcolor="#C6C3C6"></td>
				<td style="text-align: left; vertical-align:">
					<div style="width: 100%; background-color: #C6C3C6; height: 1px;"></div>
					<div id="main_content" style="padding: 10px; min-height: 200px; vertical-align: top;"><?PHP echo $vars['main_content']; ?></div>
					<div style="width: 100%; background-color: #C6C3C6; height: 1px;"></div>
				</td>
			</tr>
		</table>
		</form>
	
		<div style="width: 100%; background-color: #E7E7E7; height: 5px;"></div>
		<div class="footer">Copyright &copy; 2001-<?PHP echo $vars['year']; ?> Turnkey Web Tools, Inc.</div>
		<div style="width: 100%; background-color: #E7E7E7;; height: 4px;"></div>
		<div style="width: 100%; background-color: #C6C3C6; height: 1px;"></div>
	</body>
</html>
<?PHP

function php_ver_comp ($version1, $version2) {
    $v1 = explode('.', $version1);
    $v2 = explode('.', $version2);
   
    if ($v1[0] > $v2[0])
        $ret = 1;
    else if ($v1[0] < $v2[0])
        $ret = -1;
   
    else    // Major ver are =
    {
        if (@($v1[1] > $v2[1]))
            $ret = 1;
        else if ($v1[1] < $v2[1])
            $ret = -1;
       
        else  // Minor ver are =
        {
            if ($v1[2] > $v2[2])
                $ret = 1;
            else if ($v1[2] < $v2[2])
                $ret = -1;
            else
                $ret = 0;
        }
    }
    return $ret;
}

function ic_system_info() {
	global $php_ini_path;
	$thread_safe = false;
	$debug_build = false;
	$cgi_cli = false;
	$php_ini_path = '';
	
	ob_start();
	phpinfo(INFO_GENERAL);
	$php_info = ob_get_contents();
	ob_end_clean();
	
	foreach (split("\n",$php_info) as $line) {
		if (preg_match('/command/i',$line)) {
			continue;
		}
		
		if (preg_match('/thread safety.*(enabled|yes)/i',$line)) {
			$thread_safe = true;
		}
		
		if (preg_match('/debug.*(enabled|yes)/i',$line)) {
			$debug_build = true;
		}
		
		if (preg_match("/configuration file.*(<\/B><\/td><TD ALIGN=\"left\">| => |v\">)([^ <]*)(.*<\/td.*)?/i",$line,$match)) {
			$php_ini_path = $match[2];
			if (!@file_exists($php_ini_path)) {
				$php_ini_path = '';
			}
		}
		
		$cgi_cli = ((strpos(php_sapi_name(),'cgi') !== false) || (strpos(php_sapi_name(),'cli') !== false));
	}
		
	return array(
		'THREAD_SAFE' => $thread_safe,
		'DEBUG_BUILD' => $debug_build,
		'PHP_INI'     => $php_ini_path,
		'CGI_CLI'     => $cgi_cli);
}

function run_checks() {
	global $php_ini_path, $vars;
	$here = dirname(__FILE__); $_u = '';
	$_os = substr($_u, 0, strpos($_u, ' '));
	$_os_key = strtolower(substr($_u, 0, 3));
	$sep = (($_os_key == 'win') ? ';' : ':');
	$ok = true; $msg = ""; $outall = '';
	
	$outall = '<p>Please wait while we check which distribution of SunShop or PHP Live Helper your system needs...</p>';
	
	// Ioncube Check
	$ok = extension_loaded('ionCube Loader');
	$outall .= display_check(
		'Checking for <a href="http://www.ioncube.com/loader/" target="_NEW">Ioncube</a>', 
		($ok)?'INSTALLED':'NOT INSTALLED', 
		($ok)?'':'<p>Please look below for our recommendations.</p>', 
		($ok)?'':array('#000000', '#F88017', '#F88017')
	);
	// End Ioncube Check
	
	// Recommendation
	$color = array('#000000', '#008000', '#008000');
	if (extension_loaded('ionCube Loader')) {
		$msg = '<p>Ioncube was found on your system, further instructions are available below.</p>';
	} else {
		$msg = '<p>Because Ioncube was not found on your system, changes to your system may be necessary. Please look below for further instructions.</p>';
		$color = array('#000000', '#F88017', '#F88017');
	}
	$outall .= display_check(
		'Generating Recommendation', 
		'DONE', 
		$msg,
		$color
	);
	// End Recommendation
	
	// Instructions
	$msg = '';
	$color = array('#000000', '#008000', '#008000');
	if (extension_loaded('ionCube Loader')) {
		$msg = '<p>Download the Ioncube distribution for PHP version '.phpversion().' of SunShop or PHP Live Helper from the <a href="https://www.twt-inc.com/clients/login" target="_NEW">TWT client area</a>.</p>';
	} else {
		$color = array('#000000', '#FF0000', '#FF0000');
		$msg .= '<p>No suitable loaders were located on your system to properly install SunShop or PHP Live Helper. Please contact TWT Support or your host for additional assistance with installation.</p>';
	}
	$outall .= display_check(
		'Generating Instructions', 
		'DONE', 
		$msg."<p>For more information on installation please see the documentation in the docs/ folder.</p>",
		$color
	);
	// End Instructions
	
	$outall .= '<p><strong>Please Note:</strong> If you have trouble installing please email the location of this script to us at 
	support@twt-inc.com.</p>';
	
	$outall .= '<p><strong>Compatible Web Hosting:</strong> Please note that we do provide compatible hosting at great rates at 
	<a href="http://www.turnkeywebhosting.com/" target="_HOSTING">http://www.turnkeywebhosting.com/</a>. We will offer 
	the first month free to ANYONE having issues with their current host. Contact us for more details!</p>';
	
	return $outall;
}

function system_checks () {
	global $vars;
	$outall = '<p>Please wait while we check general software requirements...</p>';
	
	$outall .= display_check(
		'Product', 
		$vars['software'], 
		'',
		array('#000000', '#000000', '#000000')
	);
	
	$outall .= display_check(
		'Product Version', 
		$vars['version'], 
		'',
		array('#000000', '#000000', '#000000')
	);
	
	$pok = php_ver_comp(phpversion(), '5.6');
	if ($pok == -1)	$ok = false; else $ok = true;
	$outall .= display_check(
		'Checking PHP Version (Min. 5.6)',
		phpversion(), 
		($ok)?'':'<p>Please make sure that PHP version 5.6 or later is installed.</p>',
		($ok)?'':array('#000000', '#FF0000', '#FF0000')
	);
	
	if (ini_get("file_uploads") != "1")	$ok = false; else $ok= true;
	$outall .= display_check(
		'Checking PHP Setting (file_uploads)',
		($ok)?'ENABLED':'DISABLED', 
		($ok)?'':'<p>File uploading seems to be disabled in php.ini. Please set the value for file_uploads to "On" in your php.ini before installing.</p>',
		($ok)?'':array('#000000', '#FF0000', '#FF0000')
	);
	
	$max = ini_get("upload_max_filesize");
	$mok = php_ver_comp(str_replace('M', '', $max), '16');
	if ($mok == -1)	$ok = false; else $ok = true;
	$outall .= display_check(
		'Checking PHP Setting (upload_max_filesize)',
		$max, 
		($ok)?'':'<p>Consider changing the upload_max_filesize value in your php.ini to increase the maximum allowed size of uploaded files.</p>',
		($ok)?'':array('#000000', '#F88017', '#F88017')
	);
	
	$pok = php_ver_comp(phpversion(), '7');
	if ($pok == -1) {
		if (extension_loaded('mysql')) $ok = true; else $ok= false;
		$outall .= display_check(
			'Checking For PHP Extension (mysql)',
			($ok)?'INSTALLED':'NOT INSTALLED',
			($ok)?'':'<p>MySQL support must be loaded into PHP before '.$vars['software'].' will run correctly. (https://www.php.net/manual/en/book.mysql.php)</p>',
			($ok)?'':array('#000000', '#FF0000', '#FF0000')
		);
	}
	
	else {
		if (extension_loaded('pdo_mysql')) $ok = true; else $ok= false;
		$outall .= display_check(
			'Checking For PHP Extension (pdo_mysql)',
			($ok)?'INSTALLED':'NOT INSTALLED',
			($ok)?'':'<p>PDO MySQL support must be loaded into PHP before '.$vars['software'].' will run correctly. (https://www.php.net/manual/en/book.pdo.php)</p>',
			($ok)?'':array('#000000', '#FF0000', '#FF0000')
		);
	}
	
	if (extension_loaded('openssl')) $ok = true; else $ok= false;
	$outall .= display_check(
		'Checking For OpenSSL (Encryption)',
		($ok)?'INSTALLED':'NOT INSTALLED',
		($ok)?'':'<p>OpenSSL support must be loaded into PHP before '.$vars['software'].' will run correctly. (https://www.php.net/manual/en/book.openssl.php)</p>',
		($ok)?'':array('#000000', '#FF0000', '#FF0000')
	);
	
	if (extension_loaded('curl')) $ok = true; else $ok= false;
	$outall .= display_check(
		'Checking For PHP Extension (cURL)',
		($ok)?'INSTALLED':'NOT INSTALLED',
		($ok)?'':'<p>cURL is required for connecting to services for getting shipping rates and processing credit cards. Consider loading cURL support into PHP before continuing. If cURL is installed on the server, you can also use the command line version. (http://us.php.net/manual/en/curl.installation.php)</p>',
		($ok)?'':array('#000000', '#F88017', '#F88017')
	);
	
	if (extension_loaded('gd')) $ok = true; else $ok= false;
	$outall .= display_check(
		'Checking For PHP Extension (gd)',
		($ok)?'INSTALLED':'NOT INSTALLED',
		($ok)?'':'<p>GD is required for resizing uploaded images. Consider loading GD support into PHP before continuing. (https://www.php.net/manual/en/book.image.php)</p>',
		($ok)?'':array('#000000', '#F88017', '#F88017')
	);
	
	return $outall;
}